---
title: Save and Restore a Survey JSON Schema
product: Survey Creator
description: Learn how to automatically save changes made in your form contents and its settings or make the Save button visible and let users save new configurations manually. View a free demo example for JavaScript to learn more.
framework: Vanilla JS
source: https://surveyjs.io/survey-creator/examples/set-how-survey-configuration-changes-are-saved/vanillajs
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Save and Restore a Survey JSON Schema (Vanilla JS)

Survey Creator produces survey model schemas as JSON objects. You can persist these objects on your server or in the browser's <a href="https://developer.mozilla.org/en-US/docs/Web/API/Window/localStorage" target="_blank">`localStorage`</a> so that users can restore them and continue designing the survey from where they left off. In this example, Survey Creator automatically saves survey JSON schemas in the `localStorage`. To try this functionality, modify the survey and reload the page&mdash;your changes will remain.

## Persist Survey JSON Schemas

To save a survey JSON schema, implement the [`saveSurveyFunc`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#saveSurveyFunc) function. It accepts two arguments:

- `saveNo`      
An incremental number of the current change. Since web services are asynchronous, you cannot guarantee that the service receives the changes in the same order as the client sends them. For example, change #11 may arrive to the server faster than change #10. In your web service code, update the storage only if you receive changes with a higher `saveNo`.

- `callback`        
A callback function. Call it and pass `saveNo` as the first argument. Set the second argument to `true` or `false` based on whether the server applied or rejected the change.

You can access the raw survey JSON schema using the `SurveyCreatorModel`'s [`JSON`](/survey-creator/documentation/api-reference/survey-creator#JSON) property or its stringified version using the [`text`](/survey-creator/documentation/api-reference/survey-creator#text) property. Save the content of one of these properties to the preferred storage.

## Enable Auto-Save

The `saveSurveyFunc` function is called each time a survey JSON schema needs to be saved. Users can run the save operation by clicking the Save button in the toolbar. Alternatively, you can enable auto-save. This feature starts the save operation when the survey JSON schema is modified.

To activate auto-save, set the [`autoSaveEnabled`](/survey-creator/documentation/api-reference/survey-creator#autoSaveEnabled) property to `true`, as shown in this demo. Note that the Save button becomes unavailable. To avoid overloading the server with frequent requests, survey modifications are saved with a 500 ms delay. You can use the [`autoSaveDelay`](/survey-creator/documentation/api-reference/survey-creator#autoSaveDelay) property to increase or decrease this value.

## Files

### `public/index.html`

```html
<!-- Uncomment the following lines to enable Ace Editor in the JSON Editor tab -->
<!-- 
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ace.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ext-searchbox.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/theme-clouds_midnight.js"></script>
-->

<div id="surveyCreatorContainer" style="position: absolute; height: 100%; width: 100%"></div>
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import { SurveyCreator } from "survey-creator-js";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import "./index.css";
import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

const creator = new SurveyCreator({ autoSaveEnabled: true });

const localStorageKey = "survey-json-example";

creator.saveSurveyFunc = (saveNo, callback) => {
    window.localStorage.setItem(localStorageKey, creator.text);
    callback(saveNo, true);

    // If you use a web service:
    // saveSurveyJson(
    //     "https://your-web-service.com/",
    //     creator.JSON,
    //     saveNo,
    //     callback
    // );
}

const defaultJSON = {
  pages: [{
    name: 'page1',
    elements: [{
      type: 'text',
      name: "q1"
    }]
  }]
};

creator.text = window.localStorage.getItem(localStorageKey) || JSON.stringify(defaultJSON);

// If you use a web service:
// function saveSurveyJson(url, json, saveNo, callback) {
//   fetch(url, {
//     method: 'POST',
//     headers: {
//       'Content-Type': 'application/json;charset=UTF-8'
//     },
//     body: JSON.stringify(json)
//   })
//   .then(response => {
//     if (response.ok) {
//       callback(saveNo, true);
//     } else {
//       callback(saveNo, false);
//     }
//   })
//   .catch(error => {
//     callback(saveNo, false);
//   });
// }
creator.render("surveyCreatorContainer");
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest",
    "survey-creator-core": "latest",
    "survey-creator-js": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/survey-creator/examples/set-how-survey-configuration-changes-are-saved/angular.md)
- [React](https://surveyjs.io/survey-creator/examples/set-how-survey-configuration-changes-are-saved/reactjs.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/set-how-survey-configuration-changes-are-saved/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/set-how-survey-configuration-changes-are-saved/jquery.md)


---
title: Save and Restore a Survey JSON Schema
product: Survey Creator
description: Learn how to automatically save changes made in your form contents and its settings or make the Save button visible and let users save new configurations manually. View a free demo example for JavaScript to learn more.
framework: React
source: https://surveyjs.io/survey-creator/examples/set-how-survey-configuration-changes-are-saved/reactjs
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Save and Restore a Survey JSON Schema (React)

Survey Creator produces survey model schemas as JSON objects. You can persist these objects on your server or in the browser's <a href="https://developer.mozilla.org/en-US/docs/Web/API/Window/localStorage" target="_blank">`localStorage`</a> so that users can restore them and continue designing the survey from where they left off. In this example, Survey Creator automatically saves survey JSON schemas in the `localStorage`. To try this functionality, modify the survey and reload the page&mdash;your changes will remain.

## Persist Survey JSON Schemas

To save a survey JSON schema, implement the [`saveSurveyFunc`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#saveSurveyFunc) function. It accepts two arguments:

- `saveNo`      
An incremental number of the current change. Since web services are asynchronous, you cannot guarantee that the service receives the changes in the same order as the client sends them. For example, change #11 may arrive to the server faster than change #10. In your web service code, update the storage only if you receive changes with a higher `saveNo`.

- `callback`        
A callback function. Call it and pass `saveNo` as the first argument. Set the second argument to `true` or `false` based on whether the server applied or rejected the change.

You can access the raw survey JSON schema using the `SurveyCreatorModel`'s [`JSON`](/survey-creator/documentation/api-reference/survey-creator#JSON) property or its stringified version using the [`text`](/survey-creator/documentation/api-reference/survey-creator#text) property. Save the content of one of these properties to the preferred storage.

## Enable Auto-Save

The `saveSurveyFunc` function is called each time a survey JSON schema needs to be saved. Users can run the save operation by clicking the Save button in the toolbar. Alternatively, you can enable auto-save. This feature starts the save operation when the survey JSON schema is modified.

To activate auto-save, set the [`autoSaveEnabled`](/survey-creator/documentation/api-reference/survey-creator#autoSaveEnabled) property to `true`, as shown in this demo. Note that the Save button becomes unavailable. To avoid overloading the server with frequent requests, survey modifications are saved with a 500 ms delay. You can use the [`autoSaveDelay`](/survey-creator/documentation/api-reference/survey-creator#autoSaveDelay) property to increase or decrease this value.

## Files

### `public/index.html`

```html
<!-- Uncomment the following lines to enable Ace Editor in the JSON Editor tab -->
<!-- 
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ace.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/ext-searchbox.js"></script>
<script src="https://unpkg.com/ace-builds/src-min-noconflict/theme-clouds_midnight.js"></script>
-->

<div id="surveyCreatorContainer" style="position: absolute; height: 100%; width: 100%"></div>
```

### `src/SurveyCreatorComponent.jsx`

```js
import React from "react";
import { SurveyCreator, SurveyCreatorComponent } from "survey-creator-react";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";
import "./index.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

function SurveyCreatorRenderComponent() {
    const creator = new SurveyCreator({ autoSaveEnabled: true });
    const localStorageKey = "survey-json-example";
    
    creator.saveSurveyFunc = (saveNo, callback) => {
        window.localStorage.setItem(localStorageKey, creator.text);
        callback(saveNo, true);
    
        // If you use a web service:
        // saveSurveyJson(
        //     "https://your-web-service.com/",
        //     creator.JSON,
        //     saveNo,
        //     callback
        // );
    }
    
    const defaultJSON = {
      pages: [{
        name: 'page1',
        elements: [{
          type: 'text',
          name: "q1"
        }]
      }]
    };
    
    creator.text = window.localStorage.getItem(localStorageKey) || JSON.stringify(defaultJSON);
    
    // If you use a web service:
    // function saveSurveyJson(url, json, saveNo, callback) {
    //   fetch(url, {
    //     method: 'POST',
    //     headers: {
    //       'Content-Type': 'application/json;charset=UTF-8'
    //     },
    //     body: JSON.stringify(json)
    //   })
    //   .then(response => {
    //     if (response.ok) {
    //       callback(saveNo, true);
    //     } else {
    //       callback(saveNo, false);
    //     }
    //   })
    //   .catch(error => {
    //     callback(saveNo, false);
    //   });
    // }
    return (<SurveyCreatorComponent creator={creator} />);
}

export default SurveyCreatorRenderComponent;
```

### `src/index.css`

```css
/* You can add your custom CSS here. */
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyCreatorRenderComponent from "./SurveyCreatorComponent";

const root = createRoot(document.getElementById("surveyCreatorContainer"));
root.render(<SurveyCreatorRenderComponent />);
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest",
    "survey-creator-core": "latest",
    "survey-creator-react": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/survey-creator/examples/set-how-survey-configuration-changes-are-saved/angular.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/set-how-survey-configuration-changes-are-saved/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/set-how-survey-configuration-changes-are-saved/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/set-how-survey-configuration-changes-are-saved/vanillajs.md)


---
title: Save and Restore a Survey JSON Schema
product: Survey Creator
description: Learn how to automatically save changes made in your form contents and its settings or make the Save button visible and let users save new configurations manually. View a free demo example for JavaScript to learn more.
framework: Angular
source: https://surveyjs.io/survey-creator/examples/set-how-survey-configuration-changes-are-saved/angular
index: https://surveyjs.io/survey-creator/examples/overview.md
---

# Save and Restore a Survey JSON Schema (Angular)

Survey Creator produces survey model schemas as JSON objects. You can persist these objects on your server or in the browser's <a href="https://developer.mozilla.org/en-US/docs/Web/API/Window/localStorage" target="_blank">`localStorage`</a> so that users can restore them and continue designing the survey from where they left off. In this example, Survey Creator automatically saves survey JSON schemas in the `localStorage`. To try this functionality, modify the survey and reload the page&mdash;your changes will remain.

## Persist Survey JSON Schemas

To save a survey JSON schema, implement the [`saveSurveyFunc`](https://surveyjs.io/survey-creator/documentation/api-reference/survey-creator#saveSurveyFunc) function. It accepts two arguments:

- `saveNo`      
An incremental number of the current change. Since web services are asynchronous, you cannot guarantee that the service receives the changes in the same order as the client sends them. For example, change #11 may arrive to the server faster than change #10. In your web service code, update the storage only if you receive changes with a higher `saveNo`.

- `callback`        
A callback function. Call it and pass `saveNo` as the first argument. Set the second argument to `true` or `false` based on whether the server applied or rejected the change.

You can access the raw survey JSON schema using the `SurveyCreatorModel`'s [`JSON`](/survey-creator/documentation/api-reference/survey-creator#JSON) property or its stringified version using the [`text`](/survey-creator/documentation/api-reference/survey-creator#text) property. Save the content of one of these properties to the preferred storage.

## Enable Auto-Save

The `saveSurveyFunc` function is called each time a survey JSON schema needs to be saved. Users can run the save operation by clicking the Save button in the toolbar. Alternatively, you can enable auto-save. This feature starts the save operation when the survey JSON schema is modified.

To activate auto-save, set the [`autoSaveEnabled`](/survey-creator/documentation/api-reference/survey-creator#autoSaveEnabled) property to `true`, as shown in this demo. Note that the Save button becomes unavailable. To avoid overloading the server with frequent requests, survey modifications are saved with a 500 ms delay. You can use the [`autoSaveDelay`](/survey-creator/documentation/api-reference/survey-creator#autoSaveDelay) property to increase or decrease this value.

## Files

### `src/app/components/creator.component.css`

```css
/* You can define custom CSS rules here */
```

### `src/app/components/creator.component.html`

```html
<div style="position: fixed; top: 0; bottom: 0; right: 0; left: 0;">
    <survey-creator [model]="model"></survey-creator>
</div>
```

### `src/app/components/creator.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { SurveyCreatorModel } from "survey-creator-core";
import "survey-core/survey.i18n";
import "survey-creator-core/survey-creator-core.i18n";
import "survey-core/survey-core.css";
import "survey-creator-core/survey-creator-core.css";

import SurveyTheme from "survey-core/themes";
import { registerCreatorTheme } from "survey-creator-core";

registerCreatorTheme(SurveyTheme); // Add predefined Survey Creator UI themes

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey-creator",
    templateUrl: "./creator.component.html",
    styleUrls: ["./creator.component.css"]
})
export class SurveyCreatorComponent implements OnInit {
    model: SurveyCreatorModel;
    ngOnInit() {
        const creator = new SurveyCreatorModel({ autoSaveEnabled: true });
        const localStorageKey = "survey-json-example";
        
        creator.saveSurveyFunc = (saveNo, callback) => {
            window.localStorage.setItem(localStorageKey, creator.text);
            callback(saveNo, true);
        
            // If you use a web service:
            // saveSurveyJson(
            //     "https://your-web-service.com/",
            //     creator.JSON,
            //     saveNo,
            //     callback
            // );
        }
        
        const defaultJSON = {
          pages: [{
            name: 'page1',
            elements: [{
              type: 'text',
              name: "q1"
            }]
          }]
        };
        
        creator.text = window.localStorage.getItem(localStorageKey) || JSON.stringify(defaultJSON);
        
        // If you use a web service:
        // function saveSurveyJson(url, json, saveNo, callback) {
        //   fetch(url, {
        //     method: 'POST',
        //     headers: {
        //       'Content-Type': 'application/json;charset=UTF-8'
        //     },
        //     body: JSON.stringify(json)
        //   })
        //   .then(response => {
        //     if (response.ok) {
        //       callback(saveNo, true);
        //     } else {
        //       callback(saveNo, false);
        //     }
        //   })
        //   .catch(error => {
        //     callback(saveNo, false);
        //   });
        // }
        this.model = creator;
    }
}
```

### `src/app/app.component.html`

```html
<component-survey-creator></component-survey-creator>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html"
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";
import { AppComponent } from "./app.component";
import { SurveyCreatorModule } from "survey-creator-angular";
import { SurveyCreatorComponent } from "./components/creator.component";

@NgModule({
    declarations: [AppComponent, SurveyCreatorComponent],
    imports: [BrowserModule, SurveyCreatorModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
/* You can add global styles to this file and import other style files */
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css"  ],
      "scripts": [  ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-angular-ui": "latest",
    "survey-creator-core": "latest",
    "survey-core": "latest",
    "survey-creator-angular": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular-devkit/build-angular": "~13.0.0",
    "@angular/cli": "~13.0.0",
    "@types/jasmine": "3.6.3",
    "@types/jasminewd2": "2.0.8",
    "@types/node": "14.14.28",
    "codelyzer": "6.0.1",
    "jasmine-core": "3.6.0",
    "jasmine-spec-reporter": "6.0.0",
    "karma": "6.1.1",
    "karma-chrome-launcher": "3.1.0",
    "karma-coverage-istanbul-reporter": "3.0.3",
    "karma-jasmine": "4.0.1",
    "karma-jasmine-html-reporter": "1.5.4",
    "protractor": "7.0.0",
    "ts-node": "9.1.1",
    "tslint": "~6.1.3",
    "typescript": "4.1.5"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/survey-creator/examples/set-how-survey-configuration-changes-are-saved/reactjs.md)
- [Vue 3](https://surveyjs.io/survey-creator/examples/set-how-survey-configuration-changes-are-saved/vue3js.md)
- [jQuery](https://surveyjs.io/survey-creator/examples/set-how-survey-configuration-changes-are-saved/jquery.md)
- [Vanilla JS](https://surveyjs.io/survey-creator/examples/set-how-survey-configuration-changes-are-saved/vanillajs.md)
